(*
    ===========================================================================
    WEBT[o[낤(o܂ł...)
    http://www.geocities.jp/fjtkt/program/2003_0020.html
    ===========================================================================
*)

unit ping_misc;

interface

uses
    WinSock;

const
    ETHER_LEN      =   12;
    ICMP_ECHO      =    8;
    ICMP_REPLY     =    0;
    ICMP_TTL       =   11;
    ICMP_UNREACHED =    3;
    MAX_PACKET     = 1500;

type
    IpHeader = packed record
        VerLen  : Byte;
        TOS     : Byte;
        TotalLen: WORD;
        Ident   : WORD;
        Flags   : WORD;
        TTL     : Byte;
        Protocol: Byte;
        CheckSum: WORD;
        Data    : Pointer;
{
        VerLen  : Byte;
        TOS     : u_char;
        TotalLen: u_short;
        Ident   : u_short;
        Flags   : u_short;
        TTL     : u_char;
        Protocol: u_char;
        CheckSum: u_short;
        Data    : Pointer;
}
    end;

    IcmpHeader = packed record
        Typ      : Byte;
        Code     : Byte;
        CheckSum : u_short;
        Id       : u_short;
        Squence  : u_short;
        //TimeStamp: u_long;
    end;

function    InetAddress(const IPorName: string; var IP: string): integer;

implementation

(*
    =======================================================
    PHostEnt\̂h_addr_listo
    -------------------------------------------------------
    IWi  :   Ȃ
            :   PHostEnt
    ߒl        :   h_addr_list,łȂ
    l        :   Ȃ
    =======================================================
*)
function    HostAddressList(HostEntry: PHostEnt): string;
var
    ppc: PPChar;
begin
    Result := '';
    try
        ppc := PPChar(HostEntry^.h_addr_list);
        while Assigned(ppc^) do
        begin
            // ppc ́APPChar = ^PChar Ȃ̂ŁAppc^ = PChar ɂȂB
            Result := Result + ',' + inet_ntoa(PInAddr(ppc^)^);
//            Inc(ppc);
            break;
        end;
        //1ڂA΂','ɂȂĂ̂łݑ|
        Result := Copy(Result, 2, MaxInt);
    except
        ;
    end;
end;

(*
    =======================================================
    IPAhXRs[^PHostEnt쐬
    -------------------------------------------------------
    IWi  :   gethostbyaddr, gethostbyname
            :   IPAhX񂩃Rs[^
    ߒl        :   PHostEnt
    l        :   Ȃ
    =======================================================
*)
function    gethostby(const IPorName: string): PHostEnt;
var
    ip      : u_long;
begin
    // 10i\L?
    ip := inet_addr(PChar(IPorName));
    // ߂
    if ip = INADDR_NONE then
    begin
        Result := gethostbyname(PChar(IPorName));
    end else
    // 
    begin
        Result := gethostbyaddr(@ip, 4, AF_INET);
    end;
end;

(*
    =======================================================
    IPAhXRs[^琮IPAhX쐬
    -------------------------------------------------------
    IWi  :   Ȃ
            :   IPAhX񂩃Rs[^
    ߒl        :   IPAhX
    l        :   Ȃ
    =======================================================
*)
function    InetAddress(const IPorName: string; var IP: string): integer;
var
    HostEntry: PHostEnt;
begin
    // 肭ǂ
    HostEntry := gethostby(IPorName);
    IP := IPorName;

    // ŁA
    if (HostEntry <> nil) then
    begin
        Result := inet_addr(inet_ntoa(PInAddr(HostEntry^.h_addr_list^)^));
        IP := HostAddressList(HostEntry);
    end
    else
    begin
        Result := 0;
    end;
end;

end.

